﻿using System.Collections.Generic;
using Ato.EN.IntegrationServices.CodeGenerationCGTS;
using Ato.EN.IntegrationServices.CodeGenerationDDCTNS;
using Ato.EN.IntegrationServices.CodeGenerationINCDTLS;
using Ato.EN.IntegrationServices.CodeGenerationNRFI;
using Ato.EN.IntegrationServices.CodeGenerationRNTLPRPTY;

namespace Ato.EN.IntegrationServices.CodeGenerationIITR
{
    public class IITR2025Crossform
    {
        #region Entities

        // Create Variables to store the Consumed Entity objects. 
        // These are required to be lists so that we can validate the cardinality in the event that more than one schedule is submitted.

        // IITR Parent Document
        public IITR2025 iitrParentDocument = null;

        // CGTS Child Documents
        public List<CGTS2018> cgtsChildDocuments = null;

        // DDCTNS Child Documents
        public List<DDCTNS2019> ddctnsChildDocuments = null;

        // INCDTLS Child Documents
        public List<INCDTLS2025> incdtlsChildDocuments = null;

        // NRFI Child Documents
        public List<NRFI2024> nrfiChildDocuments = null;

        // RNTLPRPTY Child Documents
        public List<RNTLPRPTY2019> rntlprptyChildDocuments = null;

        #endregion Entities

        #region Entity Accessor Properties

        // Simplifies the code that uses the crossform Entity so that it does not have to access an array.

        // IITR
        public IITR2025 IITR
        {
            get { return iitrParentDocument; }
        }

        // CGTS
        public CGTS2018 CGTS
        {
            get { return cgtsChildDocuments?[0]; }
        }

        // DDCTNS
        public DDCTNS2019 DDCTNS
        {
            get { return ddctnsChildDocuments?[0]; }
        }

        // INCDTLS
        public INCDTLS2025 INCDTLS
        {
            get { return incdtlsChildDocuments?[0]; }
        }

        // NRFI
        public NRFI2024 NRFI
        {
            get { return nrfiChildDocuments?[0]; }
        }

        // RNTLPRPTY
        public RNTLPRPTY2019 RNTLPRPTY
        {
            get { return rntlprptyChildDocuments?[0]; }
        }

        #endregion Entity Accessor Properties

        #region Constructors

        public IITR2025Crossform()
        {
            // Blank constructor to support construction of object when there is an unknown number of reports.
        }

        /// <summary>
        /// Setup the Child documents with their respective entity objects.
        /// </summary>
        /// <param name="IITR2025">Consumed IITR2025 entity object - This should always be provided.</param>
        /// <param name="ddctns2019">Consumed DDCTNS2019 entity object</param>
        /// <param name="incdtls2025">Consumed INCDTLS2025 entity object</param>
        /// <param name="rntlprpty2019">Consumed RNTLPRPTY2019 entity object</param>
        /// <param name="cgts2018">Consumed CGTS2018 entity object</param>
        /// <param name="nrfi2025">Consumed NRFI entity object</param>
        public IITR2025Crossform(IITR2025 IITR2025, DDCTNS2019 ddctns2019 = null, INCDTLS2025 incdtls2025 = null, RNTLPRPTY2019 rntlprpty2019 = null, CGTS2018 cgts2018 = null, NRFI2024 nrfi2024 = null)
        {
            // Set the IITR Parent Document (This will always be provided)
            iitrParentDocument = IITR2025;

            if (ddctns2019 != null)
            {
                ddctnsChildDocuments = new List<DDCTNS2019>()
                {
                    ddctns2019
                };
            }

            if (incdtls2025 != null)
            {
                incdtlsChildDocuments = new List<INCDTLS2025>()
                {
                    incdtls2025
                };
            }

            if (rntlprpty2019 != null)
            {
                rntlprptyChildDocuments = new List<RNTLPRPTY2019>()
                {
                    rntlprpty2019
                };
            }

            if (cgts2018 != null)
            {
                cgtsChildDocuments = new List<CGTS2018>()
                {
                    cgts2018
                };
            }

            if (nrfi2024 != null)
            {
                nrfiChildDocuments = new List<NRFI2024>()
                {
                    nrfi2024
                };
            }
        }

        #endregion Constructors

    }
}